-- Cooldown Module

function SN:StartCastDelay(args)
	SN:CreateBar(args[1], args[2], args[3], args[4], args[5], args[6])
end

function SN:CoolDowns()
	
	local f = SN.F
	local m = SN.Media
	--Make the frames db local
	local v = SN.db.profile.Frames

	f.cooldowns = SN:MakeFrame("CDGroup", "cooldowns", "SN:arg4", 24)
	f.cooldowns:SetScript("OnEvent", function(self, event, ...)
		SN:UpdateCooldown(self, event, ...)
	end)

	--Register our events for the frame
	f.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.cooldowns:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	f.cooldowns:RegisterEvent("SPELL_UPDATE_USABLE")
end

function SN:UpdateCooldown(self, event, ...)

	--if event == "SPELL_UPDATE_COOLDOWN" then
	--	local arg = ...
	--	print(arg)
	--end

	if event == "SPELL_UPDATE_USABLE" then
		for i, bar in pairs(self.bars) do
			if bar:Get("SN:arg4") == "player" then
				local _, duration, enable = GetSpellCooldown(bar:Get("SN:arg2"))
				if duration == 0 then
					bar:Stop()
				end
			end
		end
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName =  ...
		local spellId, spellName, spellSchool = select(12, ...)

		--Cycle through our cooldown list
		for i, cooldown in pairs(SN.db.profile.cooldowns) do
			if type == "SPELL_CAST_SUCCESS" then
				if spellId == cooldown.id then
					--Check to see if the cd is a personal only and also if it is enable
					if (not SN.db.profile.CD.raid) and cooldown.type == "personal" and cooldown.enable then
						if sourceGUID == UnitGUID("player") then
							SN:CreateBar(self, spellId, cooldown.CD, sourceName, sourceGUID, spellName)
						end
					--Check to see if it's a raid CD and is it enabled.
					elseif (SN.db.profile.CD.raid) and cooldown.type == "raid" and cooldown.enable then
						if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
							SN:CreateBar(self, spellId, cooldown.CD, sourceName, sourceGUID, spellName)
						--Send the raid CD to see if it's supposed to be announced.
							SN:AnnounceCD(cooldown.CD, spellId, sourceName)
						end
					end
				end
			end
		end
	end
end