﻿-- Debuff Monitor

function SN:Debuffs()
	
	local f = SN.F
	local m = SN.Media
	--make the frames db local
	local v = SN.db.profile.Frames
	
	f.debuffs = SN:MakeFrame("DBGroup", "debuffs", "SN:arg4", 20)
	f.debuffs:SetScript("OnEvent", function(self, event, ...)
		SN:UpdateDebuff(self, event, ...)
	end)

	--Register our events for the frame
	f.debuffs:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.debuffs:RegisterEvent("UNIT_TARGETABLE_CHANGED")
	
end

function SN:UpdateDebuff(frame, event, ...)

	if event == "UNIT_TARGETABLE_CHANGED" then
		print(...)
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
		local spellId, spellName, spellSchool = select(12, ...)
		
		if type == "SPELL_AURA_REFRESH" then
			if sourceGUID == UnitGUID("player") then
				if destGUID == UnitGUID("target") then
					tempbar = SN:Find(frame, "SN:arg5", spellName)
					local _, _, _, _, _, dur = UnitDebuff("target", spellName)
					--Is there a bar for this debuff already?
					if tempbar ~= nil then
						tempbar:SetDuration(dur)
						tempbar:Start()
					else
						--Start a new one because there wasn't
						SN:CreateBar(frame, spellId, dur, sourceName, destGUID, spellName)
					end
				end
			end
			--Start a fresh timer since the aura is not on the target				
		elseif type == "SPELL_AURA_APPLIED" then
			if sourceGUID == UnitGUID("player") then
				if destGUID == UnitGUID("target") then
					local name, _, _, _, _, dur = UnitDebuff("target", spellName)
					if spellName == name then
						SN:CreateBar(frame, spellId, dur, sourceName, destGUID, spellName)
					end
				end
			end
		end
		--Serpent Sting refresh with Cobra Shot and Chimera Shot
		if  type == "SPELL_DAMAGE" then
			if spellId == 77767 or spellId == 53209 then
				if sourceGUID == UnitGUID("player") then
					if destGUID == UnitGUID("target") then
						tempbar = SN:Find(frame, "SN:arg5", "Serpent Sting")
						if tempbar ~= nil then
							local _, _, _, _, _, dur, expire = UnitDebuff("target", "Serpent Sting")
							local time = (expire - GetTime()) + 6
							if time > 15 then
								time = 15
							end
							tempbar:SetDuration(time)
							tempbar:Start()
						end
					end
				end
			end	
		end
	end
end	

--for i, cooldown in pairs(SN.db.profile.debuffs) do
		---- Check to see if the aura is applied and refresh the timer
		--	if type == cooldown.refresh then
		--		if spellId == cooldown.id then
		--			if cooldown.enable then 
		--				if sourceGUID == UnitGUID("player") then
		--					tempbar = SN:Find(frame, "SN:arg5", spellName)
		--					local _, _, _, _, _, dur = UnitDebuff("target", spellName)
		--					--Is there a bar for this debuff already?
		--					if tempbar ~= nil then
		--						tempbar:SetDuration(dur)
		--						tempbar:Start()
		--					else
		--						--Start a new one because there wasn't
		--						SN:CreateBar(frame, cooldown, dur, sourceName, destGUID, spellName)
		--					end
		--				end
		--			end
		--		end